!-------------------------------cg_related.f--------------------------------
! Version: 051219-1435
! Provided by T. Torii and T. Sugita
! Reference: T. Torii and T. Sugita, "Development of PRESTA-CG 
! Incorporating Combinatorial Geometry in EGS4/PRESTA", JNC TN1410 2002-201,
! Japan Nuclear Cycle Development Institute (2002).
!
!-----------------------------------------------------------------------
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|12

! ----------------------------------------------------------------------
! Required (geometry) subroutine for use with the EGS5 Code System
! ----------------------------------------------------------------------
! This is a cg-related subroutine. 
! ----------------------------------------------------------------------

!-------------------------------qadrti.f--------------------------------
! Version: 051219-1435
! Reference: JNC TN1410 2002-201
!-----------------------------------------------------------------------
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|12

! ----------------------------------------------------------------------
! Required (geometry) subroutine for use with the EGS5 Code System
! ----------------------------------------------------------------------
! This is a subroutine qadrti. 
! ----------------------------------------------------------------------
      subroutine qadrti(a,x1,x2,i)
      implicit none
      double precision a(3),x1,x2
      integer i
      double precision p,q,d,rd
c
c'    a(1)*x*x+a(2)*x+a(3)=0. ==>> (x-x1)(x-x2)=0.
c
      if(a(1).ne.0.) then
        p=a(2)/a(1)
        q=a(3)/a(1)
        p=0.5d0*p
        d=p*p-q
        if(d.lt.0.0d0) then
          rd=sqrt(-d)
          x1=-p
          x2=rd
          i=0
        elseif(d.eq.0.) then
          x1=-p
          x2=-p
          i=2
        else
          i=2
          rd=sqrt(d)
          if(p.lt.0.) then
            x1=-p+rd
            x2=q/x1
          elseif(p.eq.0.) then
            x1=rd
            x2=-rd
          else
            x1=-p-rd
            x2=q/x1
          endif
        endif
      else
        if(a(2).ne.0.) then
          x1=-a(3)/a(2)
          x2=-a(3)/a(2)
          i=2
        else
          write(6,'(1h ,a)')
     &    '<< qadrti >> parameter error : a(1) = 0. & a(2) =0.)'
          i=0
          x1=0.0d0
          x2=0.0d0
        endif
      endif
      return
      end
!-----------------last line of subroutine qadrti-----------------------
                                                                        
!-------------------------------carda.f--------------------------------
! Version: 051219-1435
! Reference: JNC TN1410 2002-201
!-----------------------------------------------------------------------
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|12

! ----------------------------------------------------------------------
! Required (geometry) subroutine for use with the EGS5 Code System
! ----------------------------------------------------------------------
! This is a subroutine carda. 
! ----------------------------------------------------------------------
      subroutine carda(aa,x1,x2,x3,i)
      implicit none
      double precision aa(4),a(4),b(4),x1,x2,x3
      double precision eps1,eps2,eps3,e,con,d,p,q,r,s,t,r1,r1c,r2c,rd,
     &                 u,v,xt1,xt2,xt3,dd,r2
      double precision theata,sr,ct,st,xmax
      integer i,ind1,ind2
c
c'    aa(1)*x*x*x+aa(2)*x*x+aa(3)*x+aa(4)=0. ==>> (x-x1)(x-x2)(x-x3)=0.
c
      ind1=0
c      eps1=1.0d-75
c      eps2=1.0d-25
      eps1=1.0d-12
      eps2=1.0d-12
      eps3=1.0d-8
      do 100 i=1,4
        a(i)=aa(i)
        b(i)=aa(i)
  100 continue
c                                                                               
      e=1.0d0/3.0d0
      con=sqrt(3.0d0)/2.0d0
      a(2)=a(2)/a(1)
      a(3)=a(3)/a(1)
      a(4)=a(4)/a(1)
c
  200 continue
        r=a(2)/3.0d0
        s=a(3)/3.0d0
        p=-(r*r)+s
        q=2.0d0*r*r*r-a(2)*s+a(4)
        if((abs(q).le.eps1).and.(abs(p).le.eps2)) go to 300
          t=p*p*p
          d=q*q+4.0d0*t
          if(abs(d).lt.eps3*(abs(q*q)+abs(4.0d0*t))) d=0.0d0
          if (d.eq.0.0d0) then
            r1=-q*0.5d0
            r1c=(abs(r1))**e
            if(r1.lt.0.) then
              r1c=-r1c
            endif
            x1=2.0d0*r1c-r
            if(abs(x1).lt.eps3*(abs(2.0d0*r1c)+abs(r))) x1=0.0d0
            x2=-r1c-r
            x3=-r1c-r
            if(abs(x2).lt.eps3*(abs(r1c)+abs(r))) then
              x2=0.0d0
              x3=0.0d0
            endif
            i=3
            return
          elseif (d.gt.0.0d0) then
            rd=sqrt(d)
            if (q.gt.0.0d0) then
              r1=(-q-rd)*0.5d0
            else
              r1=(-q+rd)*0.5d0
            endif
            r2=-t/r1
            r1c=(abs(r1))**e
            if(r1.lt.0.0d0) then
              r1c=-r1c
            endif
            r2c=(abs(r2))**e
            if(r2.lt.0.0d0) then
              r2c=-r2c
            endif
            u=r1c+r2c
            v=r1c-r2c
            xt1=u-r
            xt2=-0.5d0*u-r
            xt3=con*v
            if(ind1.eq.1) then
              if(ind2.eq.1) then
                x1=1.0d0/xt1
              else
                dd=xt2*xt2+xt3*xt3
                x2=xt2/dd
                x3=xt3/dd
              endif
              i=1
              return
            else
              if((xt1*xt1).ge.(xt2*xt2+xt3*xt3)) then
                x1=xt1
                ind2=0
              else
                x2=xt2
                x3=xt3
                ind2=1
              endif
            endif
          else
            rd=sqrt(-d)
            theata=(atan2(rd,(-q)))/3.0d0
            sr=2.0d0*sqrt(-p)
            ct=cos(theata)
            st=sin(theata)
            xt1=sr*ct-r
            r1c=-0.5d0*ct*sr
            r2c=con*st*sr
            xt2=r1c-r2c-r
            xt3=r1c+r2c-r
            if(abs(xt1).ge.max(abs(xt2),abs(xt3))) then
              xmax=xt1
            elseif(abs(xt2).ge.abs(xt3)) then
              xmax=xt2
            else
              xmax=xt3
            endif
            if(ind1.eq.1) then
              x2=1.0d0/xmax
              x3=-(b(4)/b(1))/(x1*x2)
              i=3
              return
            else
              x1=xmax
            endif
          endif
          ind1=1
          a(2)=b(3)/b(4)
          a(3)=b(2)/b(4)
          a(4)=b(1)/b(4)
          goto 200
  300 continue
      x1=-r
      x2=-r
      x3=-r
      i=3
      return
      end
C                                                                       
!-----------------------last line of subroutine carda------------------
                                                                        
!-------------------------------ferra.f--------------------------------
! Version: 051219-1435
! Reference: JNC TN1410 2002-201
!-----------------------------------------------------------------------
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|12

! ----------------------------------------------------------------------
! Required (geometry) subroutine for use with the EGS5 Code System
! ----------------------------------------------------------------------
! This is a subroutine ferra. 
! ----------------------------------------------------------------------
      subroutine ferra(a,x1,x2,x3,x4,i)
      implicit none
      double precision a(5),ca(4),aa(3),x1,x2,x3,x4
      double precision eps,b1,b2,b3,b4,bb,p,q,r,s,t,dd,u,
     &                 x1r,x1i,theata,rou,e,x2r,x2i,as,d
      double precision y1,y2,y3,z1,z2
      integer i,j,k,l
c
c'    a(1)*x*x*x*x+a(2)*x*x*x+a(3)*x*x+a(4)*x+a(5)=0.
c'     ==>> (x-x1)(x-x2)(x-x3)(x-x4)=0.
c
c      eps=1.0d-75
      eps=1.0d-12
      b1=a(2)/a(1)
      b2=a(3)/a(1)
      b3=a(4)/a(1)
      b4=a(5)/a(1)
      bb=b1/4.0d0
      p=-(3.0d0*b1*b1)/8.d0+b2
      q=-b1*p/2.d0-(b1*b1*b1)/16.0d0+b3
      r=-b1*q/8.0d0+(b1*b1*b1*b1)/256.d0-b1*b3/8.0d0+b4
      if(abs(q).le.eps) goto 200
      if(q*q/(abs(4.d0*r*p)+q*q).le.eps) goto 200
      dd=4.d0*r*p-q*q
      if(abs(dd).le.eps) goto 210
      ca(1)=1.0d0
      ca(2)=-p
      ca(3)=-4.0d0*r
      ca(4)=dd
      call carda(ca,y1,y2,y3,l)
      if(l.ne.1) y1=max(y1,y2,y3)
  220 continue
      u=y1/2.0d0
      aa(1)=1.0d0
      if(y1-p.le.0.0) then
c        write(*,*) 'y1-p,y1,p=',y1-p,y1,p
        s=0.
        t=0.
        if(u.le.0) then
          j=2
          x1=sqrt(-u)
          x2=-sqrt(-u)
        else
          j=0
          x1r=0.0d0
          x1i=sqrt(u)
        endif
      else
        s=sqrt(y1-p)
        t=q/(2.0d0*s)
        aa(2)=s
        aa(3)=-t+u
        call qadrti(aa,z1,z2,j)
        if(j.eq.2) then
          x1=z1
          x2=z2
        else
          x1r=z1
          x1i=z2
        endif
      endif
      aa(2)=-s
      aa(3)=t+u
  290 continue
      call qadrti(aa,z1,z2,k)
      if(k.eq.2) then
        x3=z1
        x4=z2
      else
        x2r=z1
        x2i=z2
      endif
      i=j+k
  260 continue
      if(i.eq.0) then
        x1=x1r-bb
        x2=x1i
        x3=x2r-bb
        x4=x2i
      elseif(i.eq.2) then
        if(j.eq.2) then
          x1=x1-bb
          x2=x2-bb
          x3=x2r-bb
          x4=x2i
        else
          x1=x3-bb
          x2=x4-bb
          x3=x1r-bb
          x4=x1i
        endif
      else
        x1=x1-bb
        x2=x2-bb
        x3=x3-bb
        x4=x4-bb
      endif
      return
  210 continue
      y1=0.0d0
      aa(1)=1.d0
      aa(2)=-p
      aa(3)=-4.0d0*r
      call qadrti(aa,y2,y3,l)
      if(l.eq.2) y1=max(y1,y2,y3)
      goto 220
  200 continue
      if(abs(r).le.eps) goto 230
      if(abs(4.d0*r)/(p*p+abs(4.d0*r)).le.eps) goto 230
      d=p*p-4.d0*r
      if(d.lt.0.) then
        e=1.d0/4.d0
        rou=r**e
        as=sqrt(-d)
        theata=(atan2(as,(-p)))*0.5d0
        x1r=rou*cos(theata)
        x1i=rou*sin(theata)
        x2r=-x1r
        x2i=x1i
        i=0 
        goto 260
      else
        aa(1)=1.d0
        aa(2)=0.0d0
        aa(3)=0.5d0*(p+sqrt(d))
        call qadrti(aa,z1,z2,j)
        if(j.eq.2) then
          x1=z1
          x2=z2
        else
          x1r=z1
          x1i=z2
        endif
        aa(3)=0.5d0*(p-sqrt(d))
        goto 290
       endif
 230   continue
        if(abs(p).le.eps) goto 300
          x1=0.0d0
          x2=0.0d0
          j=2
          aa(1)=1.d0
          aa(2)=0.d0
          aa(3)=p
          goto 290
  300 continue
      x1=-bb
      x2=x1
      x3=x1
      x4=x1
      i=4
      return
      end
!-----------------------last line of subroutine ferra.f----------------

!-------------------------------rppcg1.f--------------------------------
! Version: 051219-1435
! Reference: JNC TN1410 2002-201
!-----------------------------------------------------------------------
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|12

! ----------------------------------------------------------------------
! Required (geometry) subroutine for use with the EGS5 Code System
! ----------------------------------------------------------------------
! This is a subroutine rppcg1. 
! ----------------------------------------------------------------------
      subroutine rppcg1(izon,xl,yl,zl,unp,vnp,wnp)
      implicit none
c
      include 'auxcommons/geom_common.f' ! geom-common file
c
      double precision xl,yl,zl
      double precision unp,vnp,wnp
      integer izon
      double precision udotal
c
      if(unp.ne.0.0d0) then
        udotal=(rpppnt(1,izon)-xl)/unp
        if ((udotal.ge.0.0d0)) then
          itvalm=itvalm+1
          atval(itvalm)=udotal
        end if
        udotal=(rpppnt(2,izon)-xl)/unp
        if ((udotal.ge.0.0d0)) then
          itvalm=itvalm+1
          atval(itvalm)=udotal
        end if
      end if
      if(vnp.ne.0.0d0) then
        udotal=(rpppnt(3,izon)-yl)/vnp
        if ((udotal.ge.0.0d0)) then
          itvalm=itvalm+1
          atval(itvalm)=udotal
        end if
        udotal=(rpppnt(4,izon)-yl)/vnp
        if ((udotal.ge.0.0d0)) then
          itvalm=itvalm+1
          atval(itvalm)=udotal
        end if
      end if
      if(wnp.ne.0.0d0) then
        udotal=(rpppnt(5,izon)-zl)/wnp
        if ((udotal.ge.0.0d0)) then
          itvalm=itvalm+1
          atval(itvalm)=udotal
        end if
        udotal=(rpppnt(6,izon)-zl)/wnp
        if(udotal.ge.0.0d0) then
          itvalm=itvalm+1
          atval(itvalm)=udotal
        end if
      end if
      return
      end 
!-----------------------last line of subroutine rpcg1-------------------
                                                                        
!-------------------------------rcccg1.f--------------------------------
! Version: 051219-1435
! Reference: JNC TN1410 2002-201
!-----------------------------------------------------------------------
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|12

! ----------------------------------------------------------------------
! Required (geometry) subroutine for use with the EGS5 Code System
! ----------------------------------------------------------------------
! This is a subroutine rcccg1. 
! ----------------------------------------------------------------------
      subroutine rcccg1(izon,xl,yl,zl,unp,vnp,wnp)
      implicit none
c
      include 'auxcommons/geom_common.f' ! geom-common file
c
      double precision xl,yl,zl
      double precision unp,vnp,wnp
      integer izon
      double precision udotr
      double precision acyl,acylmv,bcyl,bcylmv,bcyln,ccyl,ccyln,dcyl,
     &                 ecylm2,fcyl,argcy,clong2,rootcy
c
      acylmv=1.0d0
      acyl= dsqrt(rccpnt(4,izon)*rccpnt(4,izon)
     &           +rccpnt(5,izon)*rccpnt(5,izon)
     &           +rccpnt(6,izon)*rccpnt(6,izon))
      bcyl=((xl-rccpnt(1,izon))*rccpnt(4,izon)
     &    + (yl-rccpnt(2,izon))*rccpnt(5,izon)
     &    + (zl-rccpnt(3,izon))*rccpnt(6,izon))/acyl
      bcylmv=(rccpnt(4,izon)*unp+rccpnt(5,izon)*vnp
     &      + rccpnt(6,izon)*wnp)/acyl
      ccyl=(xl-rccpnt(1,izon))*(xl-rccpnt(1,izon))
     &    +(yl-rccpnt(2,izon))*(yl-rccpnt(2,izon))
     &    +(zl-rccpnt(3,izon))*(zl-rccpnt(3,izon))
      dcyl=(xl-rccpnt(1,izon))*unp+(yl-rccpnt(2,izon))*vnp
     &    +(zl-rccpnt(3,izon))*wnp
      ecylm2=dabs(acylmv*acylmv-bcylmv*bcylmv)
      if(bcylmv.ne.0.d0) then
        udotr=(acyl-bcyl)/bcylmv*acylmv
        if(udotr.ge.0.d0) then
          bcyln=((xl+udotr*unp-rccpnt(1,izon))*rccpnt(4,izon)
     &          +(yl+udotr*vnp-rccpnt(2,izon))*rccpnt(5,izon)
     &          +(zl+udotr*wnp-rccpnt(3,izon))*rccpnt(6,izon))/acyl
          ccyln=(xl+udotr*unp-rccpnt(1,izon))
     &         *(xl+udotr*unp-rccpnt(1,izon))
     &         +(yl+udotr*vnp-rccpnt(2,izon))
     &         *(yl+udotr*vnp-rccpnt(2,izon))
     &         +(zl+udotr*wnp-rccpnt(3,izon))
     &         *(zl+udotr*wnp-rccpnt(3,izon))
          clong2=dabs(ccyln-bcyln*bcyln)
          if(clong2.le.
     &      (rccpnt(7,izon)+rcceps)*(1.0d0+rcceps)
     &     *(rccpnt(7,izon)+rcceps)*(1.0d0+rcceps) ) then
            itvalm=itvalm+1
            atval(itvalm)=udotr
          end if
        end if
        udotr=-bcyl/bcylmv*acylmv
        if(udotr.ge.0.0d0) then
          bcyln=((xl+udotr*unp-rccpnt(1,izon))*rccpnt(4,izon)
     &          +(yl+udotr*vnp-rccpnt(2,izon))*rccpnt(5,izon)
     &          +(zl+udotr*wnp-rccpnt(3,izon))*rccpnt(6,izon))/acyl
          ccyln=(xl+udotr*unp-rccpnt(1,izon))
     &         *(xl+udotr*unp-rccpnt(1,izon))
     &         +(yl+udotr*vnp-rccpnt(2,izon))
     &         *(yl+udotr*vnp-rccpnt(2,izon))
     &         +(zl+udotr*wnp-rccpnt(3,izon))
     &         *(zl+udotr*wnp-rccpnt(3,izon))
          clong2=dabs(ccyln-bcyln*bcyln)
          if(clong2.le.
     &      (rccpnt(7,izon)+rcceps)*(1.0d0+rcceps)
     &     *(rccpnt(7,izon)+rcceps)*(1.0d0+rcceps)) then
            itvalm=itvalm+1
            atval(itvalm)=udotr
          end if
        end if
      end if
      if(ecylm2.ne.0.0d0) then
        fcyl=(-dcyl+bcylmv*bcyl)/ecylm2
        argcy=fcyl*fcyl-(ccyl-bcyl*bcyl-rccpnt(7,izon)*rccpnt(7,izon))
     &       /ecylm2
        if(argcy.ge.0.0d0) then
          rootcy=dsqrt(argcy)
          udotr=(fcyl-rootcy)
          if(udotr.ge.0.0d0) then
            bcyln=((xl+udotr*unp-rccpnt(1,izon))*rccpnt(4,izon)
     &            +(yl+udotr*vnp-rccpnt(2,izon))*rccpnt(5,izon)
     &            +(zl+udotr*wnp-rccpnt(3,izon))*rccpnt(6,izon))/acyl
            if((bcyln+rcceps)*(1.0d0+rcceps).ge.0.0d0.and.
     &         (bcyln-rcceps)*(1.0d0-rcceps).le.acyl) then
              itvalm=itvalm+1
              atval(itvalm)=udotr
            end if
          end if
          udotr=(fcyl+rootcy)
          if(udotr.ge.0.0d0) then
            bcyln=((xl+udotr*unp-rccpnt(1,izon))*rccpnt(4,izon)
     &            +(yl+udotr*vnp-rccpnt(2,izon))*rccpnt(5,izon)
     &            +(zl+udotr*wnp-rccpnt(3,izon))*rccpnt(6,izon))/acyl
            if (((bcyln+rcceps)*(1.0d0+rcceps).ge.0.0d0.and.
     &           (bcyln-rcceps)*(1.0d0-rcceps).le.acyl)) then
              itvalm=itvalm+1
              atval(itvalm)=udotr
            end if
          end if
        end if
      end if
      return
      end 
!-----------------------last line of subroutine rcccg1------------------
                                                                        
!-------------------------------sphcg1.f--------------------------------
! Version: 051219-1435
! Reference: JNC TN1410 2002-201
!-----------------------------------------------------------------------
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|12

! ----------------------------------------------------------------------
! Required (geometry) subroutine for use with the EGS5 Code System
! ----------------------------------------------------------------------
! This is a subroutine sphcg1. 
! ----------------------------------------------------------------------
      subroutine sphcg1(izon,xl,yl,zl,unp,vnp,wnp)
      implicit none
c
      include 'auxcommons/geom_common.f' ! geom-common file
c
      double precision xl,yl,zl
      double precision unp,vnp,wnp
      integer izon
      double precision udotr
      double precision asph,bsph,csph,argsp,rootsp
      asph=1.0d0
      bsph=((xl-sphpnt(1,izon))*unp+(yl-sphpnt(2,izon))*vnp
     &    + (zl-sphpnt(3,izon))*wnp)/asph
      csph=(xl-sphpnt(1,izon))*(xl-sphpnt(1,izon))
     &    +(yl-sphpnt(2,izon))*(yl-sphpnt(2,izon))
     &    +(zl-sphpnt(3,izon))*(zl-sphpnt(3,izon))
     &    -sphpnt(4,izon)*sphpnt(4,izon)
      argsp=bsph*bsph-csph
      if(argsp.ge.0.0d0) then
        rootsp=dsqrt(argsp)
        if(csph.le.0.0d0) then
          udotr=(-bsph+rootsp)/asph
          if(udotr.ge.0.0d0) then
            itvalm=itvalm+1
            atval(itvalm)=udotr
          end if
        else
          udotr=(-bsph-rootsp)/asph
          if(udotr.ge.0.0d0) then
            itvalm=itvalm+1
            atval(itvalm)=udotr
          end if
          udotr=(-bsph+rootsp)/asph
          if(udotr.ge.0.0d0) then
            itvalm=itvalm+1
            atval(itvalm)=udotr
          end if
        end if
      end if
      return
      end 
!-----------------------last line of subroutine sphcg1------------------
                                                                        
!-------------------------------srzold.f--------------------------------
! Version: 051219-1435
! Reference: JNC TN1410 2002-201
!-----------------------------------------------------------------------
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|12

! ----------------------------------------------------------------------
! Required (geometry) subroutine for use with the EGS5 Code System
! ----------------------------------------------------------------------
! This is a subroutine srzold. 
! ----------------------------------------------------------------------
      subroutine srzold(xl,yl,zl,irlold,irlfg)
      implicit none
c
      include 'auxcommons/dataconst_common.f' ! dataconst-common file
      include 'auxcommons/geom_common.f' ! geom-common file
c
      double precision xl,yl,zl
      integer irlold,irlfg
      double precision acyl,bcyl,ccyl,clong1
      double precision thator,thstor,thetor
      integer nozone,jty,kno
      integer m,n,k,imach,imachf,ithafg
c
      irlfg=1
      do n=irlold,irlold
        imach=1
        imachf=0
        do k=1,nbbody(n)
          if(zoneor(k,n).eq.'OR'.or.zoneor(k,n).eq.'or') then
            if(imachf.eq.1.and.imach.eq.1) then
              irlfg=0
              goto 900
            else
              imachf=0
              imach=1
            end if
          end if
          m=nbzone(k,n)
          nozone=abs(nbzone(k,n))
          jty=itblty(nozone)
          kno=itblno(nozone)
c     rpp check
          if(jty.eq.ityknd(1)) then
            if(kno.ge.1.and.kno.le.irppin) then
              if(xl.lt.rpppnt(1,kno).or.xl.gt.rpppnt(2,kno).or.
     &           yl.lt.rpppnt(3,kno).or.yl.gt.rpppnt(4,kno).or.
     &           zl.lt.rpppnt(5,kno).or.zl.gt.rpppnt(6,kno)) then
                if ((m.gt.0)) then
                  imach=0
                end if
              else
                if ((m.lt.0)) then
                  imach=0
                end if
              end if
              imachf=1
            endif
c     sph check
          elseif(jty.eq.ityknd(2)) then
            if(kno.ge.1.and.kno.le.isphin) then
              if((xl-sphpnt(1,kno))*(xl-sphpnt(1,kno))
     &          +(yl-sphpnt(2,kno))*(yl-sphpnt(2,kno))
     &          +(zl-sphpnt(3,kno))*(zl-sphpnt(3,kno)) .gt.
     &          sphpnt(4,kno)*sphpnt(4,kno)) then
                if(m.gt.0) then
                  imach=0
                end if
              else
                if(m.lt.0) then
                  imach=0
                end if
              end if
              imachf=1
            end if
c     rcc check
          elseif(jty.eq.ityknd(3)) then
            if(kno.ge.1.and.kno.le.irccin) then
              acyl=dsqrt(rccpnt(4,kno)*rccpnt(4,kno)
     &                  +rccpnt(5,kno)*rccpnt(5,kno)
     &                  +rccpnt(6,kno)*rccpnt(6,kno))
              bcyl=((xl-rccpnt(1,kno))*rccpnt(4,kno)
     &            + (yl-rccpnt(2,kno))*rccpnt(5,kno)
     &            + (zl-rccpnt(3,kno))*rccpnt(6,kno))/acyl
              ccyl=(xl-rccpnt(1,kno))*(xl-rccpnt(1,kno))
     &            +(yl-rccpnt(2,kno))*(yl-rccpnt(2,kno))
     &            +(zl-rccpnt(3,kno))*(zl-rccpnt(3,kno))
              clong1=dsqrt(dabs(ccyl-bcyl*bcyl))
              if(clong1.gt.rccpnt(7,kno).or.
     &           bcyl.lt.0.0d0.or.bcyl.gt.acyl) then
                if(m.gt.0) then
                  imach=0
                end if
              else
                if(m.lt.0) then
                  imach=0
                end if
              end if
              imachf=1
            end if
c     trc check
          elseif(jty.eq.ityknd(4)) then
            if(kno.ge.1.and.kno.le.itrcin) then
              acyl=dsqrt(trcpnt(4,kno)*trcpnt(4,kno)
     &                  +trcpnt(5,kno)*trcpnt(5,kno)
     &                  +trcpnt(6,kno)*trcpnt(6,kno))
              bcyl=((xl-trcpnt(1,kno))*trcpnt(4,kno)
     &            + (yl-trcpnt(2,kno))*trcpnt(5,kno)
     &            + (zl-trcpnt(3,kno))*trcpnt(6,kno))/acyl
              ccyl=(xl-trcpnt(1,kno))*(xl-trcpnt(1,kno))
     &            +(yl-trcpnt(2,kno))*(yl-trcpnt(2,kno))
     &            +(zl-trcpnt(3,kno))*(zl-trcpnt(3,kno))
              clong1=dsqrt(dabs(ccyl-bcyl*bcyl))
              if(clong1.gt.(trcpnt(8,kno)-trcpnt(7,kno))/acyl*bcyl
     &          +trcpnt(7,kno) .or.bcyl.lt.0.0.or.bcyl.gt.acyl) then
                if(m.gt.0) then
                  imach=0
                end if
              else
                if(m.lt.0) then
                  imach=0
                end if
              end if
              imachf=1
            end if
c     tor check
          elseif(jty.eq.ityknd(5)) then
            if(kno.ge.1.and.kno.le.itorin) then
              if(nint(torpnt(8,kno)).eq.1) then
                acyl=(yl-torpnt(2,kno))*(yl-torpnt(2,kno))
     &              +(zl-torpnt(3,kno))*(zl-torpnt(3,kno))
                bcyl=xl-torpnt(1,kno)
                if(yl-torpnt(2,kno).eq.0.0d0.and.
     &             zl-torpnt(3,kno).eq.0.0d0) then
                  thator=0.0d0
                else
                  thator=atan2(zl-torpnt(3,kno),yl-torpnt(2,kno))
                end if
              end if
              if(nint(torpnt(8,kno)).eq.2) then
                acyl=(zl-torpnt(3,kno))*(zl-torpnt(3,kno))
     &              +(xl-torpnt(1,kno))*(xl-torpnt(1,kno))
                bcyl=yl-torpnt(2,kno)
                if(zl-torpnt(3,kno).eq.0.0d0.and.
     &             xl-torpnt(1,kno).eq.0.0d0) then
                  thator=0.0d0
                else
                  thator=atan2(xl-torpnt(1,kno),zl-torpnt(3,kno))
                end if
              end if
              if(nint(torpnt(8,kno)).eq.3) then
                acyl=(xl-torpnt(1,kno))*(xl-torpnt(1,kno))
     &              +(yl-torpnt(2,kno))*(yl-torpnt(2,kno))
                bcyl=zl-torpnt(3,kno)
                if(yl-torpnt(2,kno).eq.0.0d0.and.
     &             xl-torpnt(1,kno).eq.0.0d0) then
                  thator=0.0d0
                else
                  thator=atan2(yl-torpnt(2,kno),xl-torpnt(1,kno))
                end if
              end if
              thator=thator*180.0d0/PI
              thstor=torpnt(6,kno)
              thetor=torpnt(7,kno)
              if(thator.lt.0.0d0) then
                thator=thator+360.0d0
              end if
              if(thstor.lt.0.0d0) then
                thstor=thstor+360.0d0
              end if
              if(thetor.lt.0.0d0) then
                thetor=thetor+360.0d0
              end if
              ithafg=0 
              if(thstor.eq.thetor) then
                ithafg=1
              else
                if(thetor.gt.thstor) then
                  if(thator.ge.thstor.and.thator.le.thetor) then
                    ithafg=1
                  end if
                else
                  if(thator.ge.thstor.or.thator.le.thetor) then
                    ithafg=1
                  end if
                end if
              end if
              ccyl=dsqrt(acyl)-torpnt(4,kno)
              clong1=dsqrt(ccyl*ccyl+bcyl*bcyl)
              if(clong1.gt.torpnt(5,kno).or.ithafg.eq.0) then
                if(m.gt.0) then
                  imach=0
                end if
              else
                if(m.lt.0) then
                  imach=0
                end if
              end if
              imachf=1
            end if
c
c**** added new geometry
c
          end if
        end do

        if(imachf.eq.1.and.imach.eq.1) then
          irlfg=0
          goto 900
        end if
      end do
c
  900 continue
      return
      end 
!--------------------last line of subroutine srzold.f-------------------
                                                                        
!-------------------------------srzone.f--------------------------------
! Version: 051219-1435
! Reference: JNC TN1410 2002-201
! Provided as new one from T. Sugita   07/28/2004
!-----------------------------------------------------------------------
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|12
! ----------------------------------------------------------------------
! Required (geometry) subroutine for use with the EGS5 Code System
! ----------------------------------------------------------------------
! This is a subroutine srzone. 
! ----------------------------------------------------------------------
      subroutine srzone(xl,yl,zl,iray,irnow,irl)
      implicit none
c
      include 'auxcommons/dataconst_common.f' ! dataconst-common file
      include 'auxcommons/geom_common.f' ! geom-common file
c
      double precision xl,yl,zl
      integer iray,irnow,irl
      double precision acyl,bcyl,ccyl,clong1
      double precision thator,thstor,thetor
      integer n,k,imach,imachf,m,ithafg
      integer nn
      integer nozone,jty,kno
      irl=0
      do nn=1,izonin
        n=iznnxp(iray,nn,irnow)
        imach=1
        imachf=0
        do k=1,nbbody(n)
          if(zoneor(k,n).eq.'OR'.or.zoneor(k,n).eq.'or') then
            if(imachf.eq.1.and.imach.eq.1) then
              irl=n
              goto 900
            else
              imachf=0
              imach=1
            end if
          end if
c
          m=nbzone(k,n)
          nozone=abs(nbzone(k,n))
          jty=itblty(nozone)
          kno=itblno(nozone)
c     rpp check
          if(jty.eq.ityknd(1)) then
            if(kno.ge.1.and.kno.le.irppin) then
              if(xl.lt.rpppnt(1,kno).or.xl.gt.rpppnt(2,kno).or.
     &           yl.lt.rpppnt(3,kno).or.yl.gt.rpppnt(4,kno).or.
     &           zl.lt.rpppnt(5,kno).or.zl.gt.rpppnt(6,kno)) then
                if(m.gt.0) then
                  imach=0
                end if
              else
                if(m.lt.0) then
                  imach=0
                end if
              end if
              imachf=1
            end if
c     sph check
          elseif(jty.eq.ityknd(2)) then
            if(kno.ge.1.and.kno.le.isphin) then
              if((xl-sphpnt(1,kno))*(xl-sphpnt(1,kno))
     &          +(yl-sphpnt(2,kno))*(yl-sphpnt(2,kno))
     &          +(zl-sphpnt(3,kno))*(zl-sphpnt(3,kno)) .gt.
     &            sphpnt(4,kno)*sphpnt(4,kno)) then
                if(m.gt.0) then
                  imach=0
                end if
              else
                if(m.lt.0) then
                  imach=0
                end if
              end if
              imachf=1
            end if
c     rcc check
          elseif(jty.eq.ityknd(3)) then
            if(kno.ge.1.and.kno.le.irccin) then
              acyl=dsqrt(rccpnt(4,kno)*rccpnt(4,kno)
     &                  +rccpnt(5,kno)*rccpnt(5,kno)
     &                  +rccpnt(6,kno)*rccpnt(6,kno))
              bcyl=((xl-rccpnt(1,kno))*rccpnt(4,kno)
     &            + (yl-rccpnt(2,kno))*rccpnt(5,kno)
     &            + (zl-rccpnt(3,kno))*rccpnt(6,kno))/acyl
              ccyl=(xl-rccpnt(1,kno))*(xl-rccpnt(1,kno))
     &            +(yl-rccpnt(2,kno))*(yl-rccpnt(2,kno))
     &            +(zl-rccpnt(3,kno))*(zl-rccpnt(3,kno))
              clong1=dsqrt(dabs(ccyl-bcyl*bcyl))
              if(clong1.gt.rccpnt(7,kno).or.
     &             bcyl.lt.0.0d0.or.bcyl.gt.acyl) then
                if(m.gt.0) then
                  imach=0
                end if
              else
                if(m.lt.0) then
                  imach=0
                end if
              end if
              imachf=1
            end if
c     trc check
          elseif(jty.eq.ityknd(4)) then
            if(kno.ge.1.and.kno.le.itrcin) then
              acyl=dsqrt(trcpnt(4,kno)*trcpnt(4,kno)
     &                  +trcpnt(5,kno)*trcpnt(5,kno)
     &                  +trcpnt(6,kno)*trcpnt(6,kno))
              bcyl=((xl-trcpnt(1,kno))*trcpnt(4,kno)
     &            + (yl-trcpnt(2,kno))*trcpnt(5,kno)
     &            + (zl-trcpnt(3,kno))*trcpnt(6,kno))/acyl
              ccyl=(xl-trcpnt(1,kno))*(xl-trcpnt(1,kno))
     &            +(yl-trcpnt(2,kno))*(yl-trcpnt(2,kno))
     &            +(zl-trcpnt(3,kno))*(zl-trcpnt(3,kno))
              clong1=dsqrt(dabs(ccyl-bcyl*bcyl))
              if(clong1.gt.(trcpnt(8,kno)-trcpnt(7,kno))/acyl*bcyl
     &          +trcpnt(7,kno).or.bcyl.lt.0.0d0.or.bcyl.gt.acyl) then
                if(m.gt.0) then
                  imach=0
                end if
              else
                if(m.lt.0) then
                  imach=0
                end if
              end if
              imachf=1
            end if
c     tor check
          elseif(jty.eq.ityknd(5)) then
            if(kno.ge.1.and.kno.le.itorin) then
              if(nint(torpnt(8,kno)).eq.1) then
                acyl=(yl-torpnt(2,kno))*(yl-torpnt(2,kno))
     &              +(zl-torpnt(3,kno))*(zl-torpnt(3,kno))
                bcyl=xl-torpnt(1,kno)
                if(yl-torpnt(2,kno).eq.0.0d0.and.
     &               zl-torpnt(3,kno).eq.0.0d0) then
                  thator=0.0d0
                else
                  thator=atan2(zl-torpnt(3,kno),yl-torpnt(2,kno))
                end if
              end if
              if(nint(torpnt(8,kno)).eq.2) then
                acyl=(zl-torpnt(3,kno))*(zl-torpnt(3,kno))
     &              +(xl-torpnt(1,kno))*(xl-torpnt(1,kno))
                bcyl=yl-torpnt(2,kno)
                if(zl-torpnt(3,kno).eq.0.0d0.and.
     &               xl-torpnt(1,kno).eq.0.0d0) then
                  thator=0.0d0
                else
                  thator=atan2(xl-torpnt(1,kno),zl-torpnt(3,kno))
                end if
              end if
              if(nint(torpnt(8,kno)).eq.3) then
                acyl=(xl-torpnt(1,kno))*(xl-torpnt(1,kno))
     &              +(yl-torpnt(2,kno))*(yl-torpnt(2,kno))
                bcyl=zl-torpnt(3,kno)
                if(yl-torpnt(2,kno).eq.0.0d0.and.
     &               xl-torpnt(1,kno).eq.0.0d0) then
                  thator=0.0d0
                else
                  thator=atan2(yl-torpnt(2,kno),xl-torpnt(1,kno))
                end if
              end if
              thator=thator*180.0d0/PI
              thstor=torpnt(6,kno)
              thetor=torpnt(7,kno)
              if(thator.lt.0.0d0) then
                thator=thator+360.0d0
              end if
              if(thstor.lt.0.0d0) then
                thstor=thstor+360.0d0
              end if
              if(thetor.lt.0.0d0) then
                thetor=thetor+360.0d0
              end if
              ithafg=0
              if(thstor.eq.thetor) then
                ithafg=1
              else
                if(thetor.gt.thstor) then
                  if(thator.ge.thstor.and.thator.le.thetor) then
                    ithafg=1
                  end if
                else
                  if(thator.ge.thstor.or.thator.le.thetor) then
                    ithafg=1
                  end if
                end if
              end if
              ccyl=dsqrt(acyl)-torpnt(4,kno)
              clong1=dsqrt(ccyl*ccyl+bcyl*bcyl)
              if(clong1.gt.torpnt(5,kno).or.ithafg.eq.0) then
                if(m.gt.0) then
                  imach=0
                end if
              else
                if(m.lt.0) then
                  imach=0
                end if
              end if
              imachf=1
            end if
c
c**** added new geometry
c
          end if
        end do
        if(imachf.eq.1.and.imach.eq.1) then
          irl=n
          goto 900
        end if
      end do
c
  900 continue
      return
      end
!--------------------last line of subroutine srzone.f-------------------
                                                                        
!-------------------------------trccg1.f--------------------------------
! Version: 051219-1435
! Reference: JNC TN1410 2002-201
!-----------------------------------------------------------------------
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|12

! ----------------------------------------------------------------------
! Required (geometry) subroutine for use with the EGS5 Code System
! ----------------------------------------------------------------------
! This is a subroutine trccg1. 
! ----------------------------------------------------------------------
      subroutine trccg1(izon,xl,yl,zl,unp,vnp,wnp)
      implicit none
c
      include 'auxcommons/geom_common.f' ! geom-common file
c
      double precision xl,yl,zl
      double precision unp,vnp,wnp
      integer izon
      double precision udotr
      double precision hhtrc,xyztrc,uvwtrc,btrcn,ctrcn
      double precision clong2,rootcy
      double precision ddtrc,dwtrc,tbtrc,rrtrc,c2trc,bmtrc,a2trc,batrc
c
      hhtrc=dsqrt(trcpnt(4,izon)*trcpnt(4,izon)
     &           +trcpnt(5,izon)*trcpnt(5,izon)
     &           +trcpnt(6,izon)*trcpnt(6,izon))
      xyztrc=((xl-trcpnt(1,izon))*trcpnt(4,izon)
     &      + (yl-trcpnt(2,izon))*trcpnt(5,izon)
     &      + (zl-trcpnt(3,izon))*trcpnt(6,izon))/hhtrc
      uvwtrc=(trcpnt(4,izon)*unp+trcpnt(5,izon)*vnp
     &      + trcpnt(6,izon)*wnp)/hhtrc
      if(uvwtrc.lt.0.0d0) then
        if(xyztrc.ge.0.0d0) then
          udotr=-xyztrc/uvwtrc
          btrcn=((xl+udotr*unp-trcpnt(1,izon))*trcpnt(4,izon)
     &          +(yl+udotr*vnp-trcpnt(2,izon))*trcpnt(5,izon)
     &          +(zl+udotr*wnp-trcpnt(3,izon))*trcpnt(6,izon))/hhtrc
          ctrcn=(xl+udotr*unp-trcpnt(1,izon))
     &         *(xl+udotr*unp-trcpnt(1,izon))
     &         +(yl+udotr*vnp-trcpnt(2,izon))
     &         *(yl+udotr*vnp-trcpnt(2,izon))
     &         +(zl+udotr*wnp-trcpnt(3,izon))
     &         *(zl+udotr*wnp-trcpnt(3,izon))
          clong2=dabs(ctrcn-btrcn*btrcn)
          if(clong2.le.(trcpnt(7,izon)+trceps)*(1.0d0+trceps)
     &                *(trcpnt(7,izon)+trceps)*(1.0d0+trceps) ) then
            itvalm=itvalm+1
            atval(itvalm)=udotr
          end if
        end if
        if ((xyztrc.ge.hhtrc)) then
          udotr=(hhtrc-xyztrc)/uvwtrc
          btrcn=((xl+udotr*unp-trcpnt(1,izon))*trcpnt(4,izon)
     &          +(yl+udotr*vnp-trcpnt(2,izon))*trcpnt(5,izon)
     &          +(zl+udotr*wnp-trcpnt(3,izon))*trcpnt(6,izon))/hhtrc
          ctrcn=(xl+udotr*unp-trcpnt(1,izon))
     &         *(xl+udotr*unp-trcpnt(1,izon))
     &         +(yl+udotr*vnp-trcpnt(2,izon))
     &         *(yl+udotr*vnp-trcpnt(2,izon))
     &         +(zl+udotr*wnp-trcpnt(3,izon))
     &         *(zl+udotr*wnp-trcpnt(3,izon))
          clong2=dabs(ctrcn-btrcn*btrcn)
          if(clong2.le.(trcpnt(8,izon)+trceps)*(1.0d0+trceps)
     &                *(trcpnt(8,izon)+trceps)*(1.0d0+trceps) ) then
            itvalm=itvalm+1
            atval(itvalm)=udotr
          end if
        end if
      end if
      if(uvwtrc.gt.0.0d0) then
        if(xyztrc.le.0.0d0) then
          udotr=-xyztrc/uvwtrc
          btrcn=((xl+udotr*unp-trcpnt(1,izon))*trcpnt(4,izon)
     &          +(yl+udotr*vnp-trcpnt(2,izon))*trcpnt(5,izon)
     &          +(zl+udotr*wnp-trcpnt(3,izon))*trcpnt(6,izon))/hhtrc
          ctrcn=(xl+udotr*unp-trcpnt(1,izon))
     &         *(xl+udotr*unp-trcpnt(1,izon))
     &         +(yl+udotr*vnp-trcpnt(2,izon))
     &         *(yl+udotr*vnp-trcpnt(2,izon))
     &         +(zl+udotr*wnp-trcpnt(3,izon))
     &         *(zl+udotr*wnp-trcpnt(3,izon))
          clong2=dabs(ctrcn-btrcn*btrcn)
          if(clong2.le.(trcpnt(7,izon)+trceps)*(1.0d0+trceps)
     &                *(trcpnt(7,izon)+trceps)*(1.0d0+trceps) ) then
            itvalm=itvalm+1
            atval(itvalm)=udotr
          end if
        end if
        if(xyztrc.le.hhtrc) then
          udotr=(hhtrc-xyztrc)/uvwtrc
          btrcn=((xl+udotr*unp-trcpnt(1,izon))*trcpnt(4,izon)
     &          +(yl+udotr*vnp-trcpnt(2,izon))*trcpnt(5,izon)
     &          +(zl+udotr*wnp-trcpnt(3,izon))*trcpnt(6,izon))/hhtrc
          ctrcn=(xl+udotr*unp-trcpnt(1,izon))
     &         *(xl+udotr*unp-trcpnt(1,izon))
     &         +(yl+udotr*vnp-trcpnt(2,izon))
     &         *(yl+udotr*vnp-trcpnt(2,izon))
     &         +(zl+udotr*wnp-trcpnt(3,izon))
     &         *(zl+udotr*wnp-trcpnt(3,izon))
          clong2=dabs(ctrcn-btrcn*btrcn)
          if(clong2.le.(trcpnt(8,izon)+trceps)*(1.0d0+trceps)
     &                *(trcpnt(8,izon)+trceps)*(1.0d0+trceps) ) then
            itvalm=itvalm+1
            atval(itvalm)=udotr
          end if
        end if
      end if
      ddtrc=(xl-trcpnt(1,izon))*(xl-trcpnt(1,izon))
     &     +(yl-trcpnt(2,izon))*(yl-trcpnt(2,izon))
     &     +(zl-trcpnt(3,izon))*(zl-trcpnt(3,izon))
      dwtrc=-((xl-trcpnt(1,izon))*unp+(yl-trcpnt(2,izon))*vnp
     &       +(zl-trcpnt(3,izon))*wnp)
      tbtrc=(trcpnt(8,izon)-trcpnt(7,izon))/hhtrc
      rrtrc=trcpnt(7,izon)+xyztrc*tbtrc
      c2trc=ddtrc-rrtrc*rrtrc-xyztrc*xyztrc
      bmtrc=dwtrc+uvwtrc*(xyztrc+tbtrc*rrtrc)
      a2trc=1.0d0-uvwtrc*uvwtrc*(1.0d0+tbtrc*tbtrc)
      if(a2trc.eq.0.0d0) then
        udotr=c2trc/(2.0d0*bmtrc)
        if(udotr.ge.0.0d0) then
          btrcn=((xl+udotr*unp-trcpnt(1,izon))*trcpnt(4,izon)
     &          +(yl+udotr*vnp-trcpnt(2,izon))*trcpnt(5,izon)
     &          +(zl+udotr*wnp-trcpnt(3,izon))*trcpnt(6,izon))/hhtrc
          if(btrcn.ge.0.0d0.and.btrcn.le.hhtrc) then
            itvalm=itvalm+1
            atval(itvalm)=udotr
          end if
        end if
      end if
      if(a2trc.ne.0.0d0) then
        batrc=bmtrc/a2trc
        rootcy=batrc*batrc-c2trc/a2trc
        if(rootcy.ge.0.0d0) then
          udotr=batrc-dsqrt(rootcy)
          if(udotr.ge.0.0d0) then
            btrcn=((xl+udotr*unp-trcpnt(1,izon))*trcpnt(4,izon)
     &            +(yl+udotr*vnp-trcpnt(2,izon))*trcpnt(5,izon)
     &            +(zl+udotr*wnp-trcpnt(3,izon))*trcpnt(6,izon))/hhtrc
            if(btrcn.ge.0.and.btrcn.le.hhtrc) then
              itvalm=itvalm+1
              atval(itvalm)=udotr
            end if
          end if
          udotr=batrc+dsqrt(rootcy)
          if(udotr.ge.0.0d0) then
            btrcn=((xl+udotr*unp-trcpnt(1,izon))*trcpnt(4,izon)
     &            +(yl+udotr*vnp-trcpnt(2,izon))*trcpnt(5,izon)
     &            +(zl+udotr*wnp-trcpnt(3,izon))*trcpnt(6,izon))/hhtrc
            if(btrcn.ge.0.0d0.and.btrcn.le.hhtrc) then
              itvalm=itvalm+1
              atval(itvalm)=udotr
            end if
          end if
        end if
      end if
      return
      end 
!--------------------last line of subroutine trccg1.f-------------------
                                                                        
!-------------------------------torcg1.f--------------------------------
! Version: 051219-1435
! Reference: JNC TN1410 2002-201
!-----------------------------------------------------------------------
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|12

! ----------------------------------------------------------------------
! Required (geometry) subroutine for use with the EGS5 Code System
! ----------------------------------------------------------------------
! This is a subroutine torcg1. 
! ----------------------------------------------------------------------
      subroutine torcg1(izon,xl,yl,zl,unp,vnp,wnp)
      implicit none
c
      include 'auxcommons/dataconst_common.f' ! dataconst-common file
      include 'auxcommons/geom_common.f' ! geom-common file
c
      double precision xl,yl,zl
      double precision unp,vnp,wnp
      double precision xyztor,xxtor,yytor,zztor,uvwtor,a(5)
      integer izon
      double precision uxvywz,sstor
      double precision x1,x2,x3,x4,clonga(4)
      double precision thator,thstor,thetor
      double precision xlnew,ylnew,zlnew,clong1
      double precision torll1,torll2,torll3,ator,btor,
     &                 utora1,utora2,utora3
      double precision etor1,ftor1,gtor1,etor2,ftor2,gtor2,rtor1
      integer i,ifg
c
      xxtor=xl-torpnt(1,izon)
      yytor=yl-torpnt(2,izon)
      zztor=zl-torpnt(3,izon)
      if(nint(torpnt(8,izon)).eq.1) then
        uvwtor=unp
        xyztor=xxtor
      end if 
      if(nint(torpnt(8,izon)).eq.2) then
        uvwtor=vnp
        xyztor=yytor
      end if
      if(nint(torpnt(8,izon)).eq.3) then
        uvwtor=wnp
        xyztor=zztor
      end if
      uxvywz=unp*xxtor+vnp*yytor+wnp*zztor
      sstor=xxtor*xxtor+yytor*yytor+zztor*zztor
     &     -torpnt(5,izon)*torpnt(5,izon)-torpnt(4,izon)*torpnt(4,izon)
      a(1)=1.0d0
      a(2)=4.0d0*uxvywz
      a(3)=4.0d0*uxvywz*uxvywz+2.0d0*sstor
     &    +4.0d0*torpnt(4,izon)*torpnt(4,izon)*uvwtor*uvwtor
      a(4)=4.0d0*uxvywz*sstor
     &    +8.0d0*torpnt(4,izon)*torpnt(4,izon)*uvwtor*xyztor
      a(5)=sstor*sstor+4.0d0*torpnt(4,izon)*torpnt(4,izon)
     &    *(xyztor*xyztor-torpnt(5,izon)*torpnt(5,izon))
      call ferra(a,x1,x2,x3,x4,ifg)
      clonga(1)=x1
      clonga(2)=x2
      clonga(3)=x3
      clonga(4)=x4
      thstor=torpnt(6,izon)
      thetor=torpnt(7,izon)
      if(thstor.gt.180.d0) then
        thstor=thstor-360.0d0
      end if
      if(thetor.gt.180.0d0) then
        thetor=thetor-360.0d0
      end if
      thstor=thstor/180.0d0*PI
      thetor=thetor/180.0d0*PI
      do i=1,ifg
        if(clonga(i).ge.0.0d0) then
          xlnew=xl+clonga(i)*unp
          ylnew=yl+clonga(i)*vnp
          zlnew=zl+clonga(i)*wnp
          if(nint(torpnt(8,izon)).eq.1) then
            if(zlnew.eq.0.0d0.and.ylnew.eq.0.0d0) then
              thator=0.0d0
            else
              thator=atan2(zlnew,ylnew)
            end if
          end if
          if(nint(torpnt(8,izon)).eq.2) then
            if(xlnew.eq.0.0d0.and.zlnew.eq.0.0d0) then
              thator=0.0d0
            else
              thator=atan2(xlnew,zlnew)
            end if
          end if
          if(nint(torpnt(8,izon)).eq.3) then
            if(ylnew.eq.0.0d0.and.xlnew.eq.0.0d0) then
              thator=0.0d0
            else
              thator=atan2(ylnew,xlnew)
            end if
          end if
          if(thetor.eq.thstor) then
            itvalm=itvalm+1
            atval(itvalm)=clonga(i)
          end if
          if(thetor.gt.thstor) then
            if ((thator.ge.thstor.and.thator.le.thetor)) then
              itvalm=itvalm+1
              atval(itvalm)=clonga(i)
            end if
          end if
          if(thetor.lt.thstor) then
            if ((thator.ge.thstor.or.thator.le.thetor)) then
              itvalm=itvalm+1
              atval(itvalm)=clonga(i)
            end if
          end if
        end if
      end do
      if(thetor.ne.thstor) then
        if(nint(torpnt(8,izon)).eq.1) then
          torll1=xl-torpnt(1,izon)
          torll2=yl-torpnt(2,izon)
          torll3=zl-torpnt(3,izon)
          utora1=unp
          utora2=vnp
          utora3=wnp
        end if
        if(nint(torpnt(8,izon)).eq.2) then
          torll1=yl-torpnt(2,izon)
          torll2=zl-torpnt(3,izon)
          torll3=xl-torpnt(1,izon)
          utora1=vnp
          utora2=wnp
          utora3=unp
        end if
        if(nint(torpnt(8,izon)).eq.3) then
          torll1=zl-torpnt(3,izon)
          torll2=xl-torpnt(1,izon)
          torll3=yl-torpnt(2,izon)
          utora1=wnp
          utora2=unp
          utora3=vnp
        end if
        ator=torll2*torll2+torll3*torll3
        btor=torll1*torll1
        if(torll2.eq.0.0d0.and.torll3.eq.0.0d0) then
          thator=0.0d0
        else
          thator=atan2(torll3,torll2)
        end if
        etor1=(torll2-torpnt(4,izon)*dcos(thstor))**2
     &   +(torll3-torpnt(4,izon)*dsin(thstor))**2 +torll1*torll1
        ftor1=(torll2-torpnt(4,izon)*dcos(thstor))*(-dsin(thstor))
     &       +(torll3-torpnt(4,izon)*dsin(thstor))*dcos(thstor)
        gtor1=utora2*(-dsin(thstor))+utora3*dcos(thstor)
        if((ftor1.gt.0.0d0.and.gtor1.lt.0.0d0).or.
     &     (ftor1.lt.0.0d0.and.gtor1.gt.0.0d0)) then
          clong1=-ftor1/gtor1
          rtor1=(torll2+utora2*clong1-torpnt(4,izon)*dcos(thstor))**2
     &         +(torll3+utora3*clong1-torpnt(4,izon)*dsin(thstor))**2
     &         +(torll1+utora1*clong1)*(torll1+utora1*clong1)
          if(rtor1.le.torpnt(5,izon)*torpnt(5,izon)) then
            itvalm=itvalm+1
            atval(itvalm)=clong1
          end if
        end if
        etor2=(torll2-torpnt(4,izon)*dcos(thetor))**2
     &       +(torll3-torpnt(4,izon)*dsin(thetor))**2 +torll1*torll1
        ftor2=(torll2-torpnt(4,izon)*dcos(thetor))*(-dsin(thetor))
     &       +(torll3-torpnt(4,izon)*dsin(thetor))*dcos(thetor)
        gtor2=utora2*(-dsin(thetor))+utora3*dcos(thetor)
        if((ftor2.gt.0.0d0.and.gtor2.lt.0.0d0).or.
     &     (ftor2.lt.0.0d0.and.gtor2.gt.0.0d0)) then
          clong1=-ftor2/gtor2
          rtor1=(torll2+utora2*clong1-torpnt(4,izon)*dcos(thetor))**2
     &         +(torll3+utora3*clong1-torpnt(4,izon)*dsin(thetor))**2
     &         +(torll1+utora1*clong1)*(torll1+utora1*clong1)
          if(rtor1.le.torpnt(5,izon)*torpnt(5,izon)) then
            itvalm=itvalm+1
            atval(itvalm)=clong1
          end if
        end if
      end if
      return
      end
!--------------------last line of subroutine torcg1.f-------------------
                                                                        
!-------------------------------block data cgtype-----------------------
! Version: 060117-0900
! Reference: JNC TN1410 2002-201
!-----------------------------------------------------------------------
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|12

! ----------------------------------------------------------------------
! Required (geometry) subroutine for use with the EGS5 Code System
! ----------------------------------------------------------------------
! This is a block data cgtype.
! ----------------------------------------------------------------------
      block data cgtype
      include 'auxcommons/geom_common.f' ! geom-common file
      data ityknd/1,2,3,4,5,0,0,0,0,0/
      data cgmnst/1.0d-4/
      data cgeps1/1.0d-4/
      data cgeps2/1.0d-4/
      data rcceps/1.0d-4/
      data trceps/1.0d-4/
      end
!--------------------last line of block data cgtype---------------------
                                                                        
!-------------------------------stgeom.f--------------------------------
! Version: 051219-1435
! Reference: JNC TN1410 2002-201
!-----------------------------------------------------------------------
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|12

! ----------------------------------------------------------------------
! Required (geometry) subroutine for use with the EGS5 Code System
! ----------------------------------------------------------------------
! This is a subroutine stgeom. 
! ----------------------------------------------------------------------
      subroutine stgeom(chkey,igmid,gmdata)
      implicit none
c
      include 'auxcommons/geom_common.f' ! geom-common file
c
      integer igmid
      character chkey*3
      double precision gmdata(10)
      integer i
      if(chkey.eq.'RPP'.or.chkey.eq.'rpp')then
        itbody=itbody+1
        irppin=irppin+1
        if(irppin.gt.MAX_RPP) then
          write(*,*) 'Dimension over of RPP=',MAX_RPP
          stop
        endif
        nbrpp(irppin)=igmid
        irppuse(irppin)=0
        igmmax = max(igmmax,igmid)
        if(igmmax.gt.MAX_GEOM) then
          write(*,*) 'Dimension over of GEOM=',MAX_GEOM
          stop
        endif
        do i=1,6
          rpppnt(i,irppin)=gmdata(i)
        end do
        itblty(igmid)=ityknd(1)
        itblno(igmid)=irppin
      elseif(chkey.eq.'SPH'.or.chkey.eq.'sph') then
        itbody=itbody+1
        isphin=isphin+1
        if(isphin.gt.MAX_SPH) then
          write(*,*) 'Dimension over of SPH=',MAX_SPH
          stop
        endif
        nbsph(isphin)=igmid
        isphuse(isphin)=0
        igmmax = max(igmmax,igmid)
        if(igmmax.gt.MAX_GEOM) then
          write(*,*) 'Dimension over of GEOM=',MAX_GEOM
          stop
        endif
        do i=1,4
          sphpnt(i,isphin)=gmdata(i)
        end do
        itblty(igmid)=ityknd(2)
        itblno(igmid)=isphin
      elseif(chkey.eq.'RCC'.or.chkey.eq.'rcc') then
        itbody=itbody+1
        irccin=irccin+1
        if(irccin.gt.MAX_RCC) then
          write(*,*) 'Dimension over of RCC=',MAX_RCC
          stop
        endif
        nbrcc(irccin)=igmid
        irccuse(irccin)=0
        igmmax = max(igmmax,igmid)
        if(igmmax.gt.MAX_GEOM) then
          write(*,*) 'Dimension over of GEOM=',MAX_GEOM
          stop
        endif
        do i=1,7
          rccpnt(i,irccin)=gmdata(i)
        end do
        itblty(igmid)=ityknd(3)
        itblno(igmid)=irccin
      elseif(chkey.eq.'TRC'.or.chkey.eq.'trc') then
        itbody=itbody+1
        itrcin=itrcin+1
        if(itrcin.gt.MAX_TRC) then
          write(*,*) 'Dimension over of TRC=',MAX_TRC
          stop
        endif
        nbtrc(itrcin)=igmid
        itrcuse(itrcin)=0
        igmmax = max(igmmax,igmid)
        if(igmmax.gt.MAX_GEOM) then
          write(*,*) 'Dimension over of GEOM=',MAX_GEOM
          stop
        endif
        do i=1,8
          trcpnt(i,itrcin)=gmdata(i)
        end do
        itblty(igmid)=ityknd(4)
        itblno(igmid)=itrcin
      elseif(chkey.eq.'TOR'.or.chkey.eq.'tor') then
        itbody=itbody+1
        itorin=itorin+1
        if(itorin.gt.MAX_TOR) then
          write(*,*) 'Dimension over of TOR=',MAX_TOR
          stop
        endif
        nbtor(itorin)=igmid
        itoruse(itorin)=0
        igmmax = max(igmmax,igmid)
        if(igmmax.gt.MAX_GEOM) then
          write(*,*) 'Dimension over of GEOM=',MAX_GEOM
          stop
        endif
        do i=1,8
          torpnt(i,itorin)=gmdata(i)
        end do
        itblty(igmid)=ityknd(5)
        itblno(igmid)=itorin
      endif
      return
      end
!--------------------last line of subroutine stgeom.f------------------
                                                                        
!-------------------------------stzone.f--------------------------------
! Version: 051219-1435
! Reference: JNC TN1410 2002-201
!-----------------------------------------------------------------------
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|12

! ----------------------------------------------------------------------
! Required (geometry) subroutine for use with the EGS5 Code System
! ----------------------------------------------------------------------
! This is a subroutine stzone. 
! ----------------------------------------------------------------------
      subroutine stzone(chkey,iznid,iznor,izndt,iprm)
      implicit none
c
      include 'auxcommons/geom_common.f' ! geom-common file
c
      integer iznid,iprm
      character chkey*3
      character iznor(MAX_IZN)*2
      integer izndt(MAX_IZN)
      integer i
      izonin = izonin + 1
      if(izonin.gt.MAX_ZONE) then
        write(*,*) 'Dimension over of ZONE=',MAX_ZONE
        stop
      endif
      zoneid(izonin) = chkey
      nbbody(izonin) = iprm
      if(iprm.gt.MAX_BODY) then
        write(*,*) 'Dimension over of BODY=',MAX_BODY
        stop
      endif
      do i=1,iprm
        zoneor(i,izonin) = iznor(i)
        nbzone(i,izonin) = izndt(i)
        call zonegeom(abs(izndt(i)))
      end do
      return
      end
!--------------------last line of subroutine stzone.f-------------------

!-------------------------------zonegeom.f------------------------------
! Version: 051219-1435
! Reference: JNC TN1410 2002-201
!-----------------------------------------------------------------------
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|12

! ----------------------------------------------------------------------
! Required (geometry) subroutine for use with the EGS5 Code System
! ----------------------------------------------------------------------
! This is a subroutine zonegeom
! ----------------------------------------------------------------------
      subroutine zonegeom(izndt)
      implicit none
c
      include 'auxcommons/geom_common.f' ! geom-common file
      integer izndt,i
c
      do i=1,irppin
        if(nbrpp(i).eq.izndt) then
          irppuse(i)=1
          goto 190
        endif
      end do
      do i=1,isphin
        if(nbsph(i).eq.izndt) then
          isphuse(i)=1
          goto 190
        endif
      end do
      do i=1,irccin
        if(nbrcc(i).eq.izndt) then
          irccuse(i)=1
          goto 190
        endif
      end do
      do i=1,itrcin
        if(nbtrc(i).eq.izndt) then
          itrcuse(i)=1
          goto 190
        endif
      end do
      do i=1,itorin
        if(nbtor(i).eq.izndt) then
          itoruse(i)=1
          goto 190
        endif
      end do
  190 continue
      return
      end
!--------------------last line of subroutine zonegeom.f-----------------
                                                                        
!-------------------------------geomgt.f--------------------------------
! Version: 051219-1435
! Reference: JNC TN1410 2002-201
!-----------------------------------------------------------------------
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|12

! ----------------------------------------------------------------------
! Required (geometry) subroutine for use with the EGS5 Code System
! ----------------------------------------------------------------------
! This is a subroutine geomgt. 
! ----------------------------------------------------------------------
      subroutine geomgt(ifti,ifto)
      implicit none
      include 'auxcommons/geom_common.f' ! geom-common file
      integer ifti,ifto
      character chkey*3
      double precision gmdata(10)
      character iznor(MAX_IZN)*2
      integer izndt(MAX_IZN)
      integer ioptid
      data ioptid/0/
      integer i,j,jps,jpe,iznid,igmid,iprm
100   continue
      call freegm(ifti,ifto,chkey,igmid,gmdata,iprm)
      if((chkey.eq.'   '))then
        write(ifto,'(a)') ' geom data error : not found [ end ]'
        goto 900
      elseif(chkey.eq.'END'.or.chkey.eq.'end') then
        write(ifto,6000) chkey
6000  format(1h ,2x,a3,i5,1p8e12.4)
        goto 200
      else
        write(ifto,6000) chkey,igmid,(gmdata(i),i=1,iprm)
        call stgeom(chkey,igmid,gmdata)
      endif
      goto 100
200   continue
      call freezn(ifti,ifto,chkey,iznid,iznor,izndt,iprm,ioptid,
     &            MAX_IZN)
      if((chkey.eq.'   '))then
        write(ifto,'(a)') ' zone data error : not found [ end ]'
        goto 900
      elseif(chkey.eq.'END'.or.chkey.eq.'end') then
        write(ifto,6000) chkey
        goto 300
      else
        do i=1,iprm,10
          jps = i
          jpe = min(iprm,i+9)
          if((i.eq.1))then
            if((ioptid.eq.0))then
              write(ifto,6200) chkey,(iznor(j),izndt(j),j=jps,jpe)
6200  format(1h ,2x,a3,5x,1x,10(a2,i5,1x))
            else
              write(ifto,6250) chkey,iznid,(iznor(j),izndt(j),
     &                                                     j=jps,jpe)
6250  format(1h ,2x,a3,i5,1x,10(a2,i5,1x))
            endif
          else
            write(ifto,6300) (iznor(j),izndt(j),j=jps,jpe)
6300  format(1h ,10x ,1x,10(a2,i5,1x))
          endif
        end do
        call stzone(chkey,iznid,iznor,izndt,iprm)
      endif
      goto 200
900   continue
      stop
300   continue
c
      call setnxt                      
c
      return
      end
!--------------------last line of subroutine geomgt.f------------------
                                                                        
!-------------------------------setnxt.f--------------------------------
! Version: 051219-1435
! Reference: JNC TN1410 2002-201
!-----------------------------------------------------------------------
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|12

! ----------------------------------------------------------------------
! Required (geometry) subroutine for use with the EGS5 Code System
! ----------------------------------------------------------------------
! This is a subroutine setnxt.
! ----------------------------------------------------------------------
      subroutine setnxt
      implicit none
c
      include 'auxcommons/geom_common.f' ! geom-common file
      integer i,j,l,jj,l1,l2,ll
c
      l=0
      do i=1,3
        iznnxs(i,1)=0
        iznnxs(i,2)=0
        do j=1,izonin
          iznnxt(i,j,l)=j
          iznnxc(i,j,l)=0
        enddo
      enddo
      do i=1,3
        do j=1,izonin
          iznnxp(i,iznnxt(i,j,l),l)=j
        enddo
c       write(*,*) 'i,izonnxp=',i,(iznnxp(i,j,l),j=1,izonin)
      enddo
      do l=1,izonin
        l1=l-1
        l2=izonin-l
        ll=min(l1,l2)
        do j=1,izonin
          if(j.eq.l) then
c           jj=izonin
            jj=0
          elseif(iabs(j-l).gt.ll) then
            jj=iabs(j-l)+ll
          elseif(j.lt.l) then
           jj=2*(l-j)
          else
           jj=2*(j-l)-1
          endif
          do i=1,3
c           iznnxt(i,j,l)=jj
            iznnxt(i,j,l)=jj+1
            iznnxc(i,j,l)=0
          enddo
        enddo
      enddo
      do l=1,izonin
        do j=1,izonin
          do i=1,3
            iznnxp(i,iznnxt(i,j,l),l)=j
          enddo
        enddo
        do i=1,3
c         write(*,*) 'i,izonnxp=',i,(iznnxp(i,j,l),j=1,izonin)
        enddo
      enddo
      return
      end
!--------------------last line of subroutine setnxt.f------------------

!-------------------------------rstnxt.f--------------------------------
! Version: 051219-1435
! Reference: JNC TN1410 2002-201
!-----------------------------------------------------------------------
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|12

! ----------------------------------------------------------------------
! Required (geometry) subroutine for use with the EGS5 Code System
! ----------------------------------------------------------------------
! This is a subroutine rstnxt.
! ----------------------------------------------------------------------
      subroutine rstnxt(iray,irold,irnew)                     
      implicit none
c
      include 'auxcommons/geom_common.f' ! geom-common file
      integer iray,irold,irnew
      integer i,j,ll,n,ns,ne,jj
      integer icknxt,ickmin,id,ik,k
      data icknxt/100000000/
      data ickmin/1000/
      integer itbl(max_zone),itbl1
c
   
      if(irold.eq.0) then
        ll=1
        ns=0
        ne=0
      else
        ll=2
        ns=1
        ne=izonin
      endif   
      if(iznnxs(iray,ll).lt.icknxt) then
        iznnxs(iray,ll)=iznnxs(iray,ll)+1
        iznnxc(iray,irnew,irold)=iznnxc(iray,irnew,irold)+1
        if(mod(iznnxs(iray,ll),ickmin).eq.0) then
          ik=0
          k=1
  100     continue
          id=k*ickmin
          if(iznnxs(iray,ll).eq.id) then
            ik=1
          elseif(id.lt.icknxt) then
            k=k*10
            goto 100
          endif
c
          if(ik.eq.1) then
            do n=ns,ne
              if(ll.eq.1) then
                do j=1,izonin
                  itbl(j)=j
                enddo
              else
                itbl(1)=n
                jj=0
                do j=2,izonin
                   jj=jj+1
                  if(jj.eq.n) then
                    jj=jj+1
                   endif
                   itbl(j)=jj
                enddo
              endif
              do i=1,izonin-1
                do j=i+1,izonin
                  if(ll.eq.1.or.i.ne.1) then
                    if(iznnxc(iray,itbl(j),n).gt.
     &                 iznnxc(iray,itbl(i),n)) then
                       itbl1=itbl(j)
                       itbl(j)=itbl(i)
                       itbl(i)=itbl1
                    elseif(iznnxc(iray,itbl(j),n).eq.
     &                     iznnxc(iray,itbl(i),n)) then
                      if(iznnxt(iray,itbl(j),n).lt.
     &                   iznnxt(iray,itbl(i),n)) then
                        itbl1=itbl(j)
                        itbl(j)=itbl(i)
                        itbl(i)=itbl1
                      endif
                    endif
                  endif
                enddo
              enddo
              do j=1,izonin
                iznnxt(iray,itbl(j),n)=j
              enddo
              do j=1,izonin
                iznnxp(iray,iznnxt(iray,j,n),n)=j
              enddo
c             write(*,*) 'iray,ir,iznnxt=',
c    &                    iray,n,(iznnxt(iray,j,n),j=1,izonin)
c             write(*,*) 'iray,ir,iznnxp=',
c    &                    iray,n,(iznnxp(iray,j,n),j=1,izonin)
c             write(*,*) 'iray,ir,iznnxc=',
c    &                    iray,n,(iznnxc(iray,j,n),j=1,izonin)
            enddo
          endif
        endif
      endif
      return
      end
!--------------------last line of subroutine rstnxt.f------------------
                                                                        
!-------------------------------getnxt.f--------------------------------
! Version: 051219-1435
! Reference: JNC TN1410 2002-201
!-----------------------------------------------------------------------
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|12

! ----------------------------------------------------------------------
! Required (geometry) subroutine for use with the EGS5 Code System
! ----------------------------------------------------------------------
! This is a subroutine getnxt.
! ----------------------------------------------------------------------
      subroutine getnxt(iray,jj,irnow,inext)                     
      implicit none
      include 'auxcommons/geom_common.f' ! geom-common file
      integer iray,jj,irnow,inext
      inext=iznnxp(iray,jj,irnow)
      return
      end
!--------------------last line of subroutine gettxt.f------------------
                                                                        
!-------------------------------freegm.f--------------------------------
! Version: 051219-1435
! Reference: JNC TN1410 2002-201
!-----------------------------------------------------------------------
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|12

! ----------------------------------------------------------------------
! Required (geometry) subroutine for use with the EGS5 Code System
! ----------------------------------------------------------------------
! This is a subroutine freegm. 
! ----------------------------------------------------------------------
      subroutine freegm(ifti,ifto,chkey,igmid,gmdata,iprm)
      implicit none
      integer ifti,ifto,igmid,iprm
      character chkey*3
      double precision gmdata(1)
      character chin*80
      integer istbl(200),ietbl(200)
      character gmtyps(6)*3,gmtypl(6)*3
      integer ityppm(6)
      integer igmtyp
      data igmtyp/6/
      data gmtypl/'END','RPP','SPH','RCC','TRC','TOR'/
      data gmtyps/'end','rpp','sph','rcc','trc','tor'/
      data ityppm/ 0, 6, 4, 7, 8, 8/
      integer i,j,ino,ich,inonw,ichs,iche,inost,ikey,ichkfg
      inonw = 0
      chkey = '   '
      iprm = 0
      ichs = 1
      iche = 80
100   continue
      read(ifti,'(a)',end=990) chin
      call splitc(chin,ich,ichs,iche,ino,istbl,ietbl)
      if((ino.eq.0))goto 100
      if(((ietbl(1)-istbl(1)).ne.2))goto 990
      chkey = chin(istbl(1):ietbl(1))
      inost = 2
      do i=1,igmtyp
        if(chkey.eq.gmtypl(i).or.chkey.eq.gmtyps(i))then
          ikey = i
          iprm = ityppm(i)
          goto 220
        endif
      end do
      goto 990
220   continue
      if((ikey.eq.1))goto 900
      if((ino.ne.1))goto 400
300   continue
      read(ifti,'(a)',end=990) chin
      call splitc(chin,ich,ichs,iche,ino,istbl,ietbl)
      if((ino.eq.0))goto 300
      inost = 1
400   continue
      if((inonw.eq.0))then
      j = ietbl(inost)-istbl(inost)+1
      call chkint(chin(istbl(inost):ietbl(inost)),j,ichkfg)
      if((ichkfg.ne.0))goto 990
      read(chin(istbl(inost):ietbl(inost)),*) igmid
      inost = inost + 1
      endif
      do i=inost,ino
        inonw = inonw + 1
        if((inonw.gt.ityppm(ikey)))goto 990
        j = ietbl(i)-istbl(i)+1
        call chkflt(chin(istbl(i):ietbl(i)),j,ichkfg)
        if((ichkfg.ne.0))goto 990
        read(chin(istbl(i):ietbl(i)),*) gmdata(inonw)
      end do
      if((inonw.lt.ityppm(ikey)))goto 300
900   continue
      return
990   continue
      write(ifto,'(a,a)') ' geom data error : ',chkey
      write(ifto,'(a)') chin
      stop
      end
!--------------------last line of subroutine freegm.f------------------
                                                                        
!-------------------------------freezn.f--------------------------------
! Version: 051219-1435
! Reference: JNC TN1410 2002-201
!-----------------------------------------------------------------------
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|12

! ----------------------------------------------------------------------
! Required (geometry) subroutine for use with the EGS5 Code System
! ----------------------------------------------------------------------
! This is a subroutine freezn. 
! ----------------------------------------------------------------------
      subroutine freezn(ifti,ifto,chkey,iznid,iznor,izndt,iprm,ioptid,
     &                  MAX_IZN)
      implicit none
      integer ifti,ifto,iznid,iprm,ioptid
      integer  MAX_IZN
      character chkey*3,iznor(1)*2
      integer izndt(1)
      character chin*80
      integer istbl(200),ietbl(200)
      character zntypl(2)*3,zntyps(2)*3
      integer izntyp
      data izntyp/2/
      data zntypl/'END','ZON'/
      data zntyps/'end','zon'/
      integer i,j,inonw,ichs,iche,inost,ikey,
     &        ino,ich,ichkfg
      inonw = 0
      chkey = '   '
      iprm = 0
      ichs = 1
      iche = 80
      iznor(1) = '  '
100   continue
      read(ifti,'(a)',end=990) chin
      call splitc(chin,ich,ichs,iche,ino,istbl,ietbl)
      if((ino.eq.0))goto 100
      j = ietbl(1)-istbl(1)+1
      call chkint(chin(istbl(1):ietbl(1)),j,ichkfg)
      if((ichkfg.eq.0))goto 990
      inost = 2
      ikey = 0
      if(((ietbl(1)-istbl(1)).gt.3))goto 990
      chkey = chin(istbl(1):ietbl(1))
      if(((ietbl(1)-istbl(1)).ne.2))goto 220
      do i=1,izntyp
        if(chkey.eq.zntypl(i).or.chkey.eq.zntyps(i))then
          ikey = i
          goto 220
        endif
      end do
220   continue
      if((ikey.eq.1))goto 900
      if((ino.ne.1))goto 400
300   continue
      read(ifti,'(a)',end=990) chin
      call splitc(chin,ich,ichs,iche,ino,istbl,ietbl)
      if((ino.eq.0))goto 300
      j = ietbl(1)-istbl(1)+1
      call chkint(chin(istbl(1):ietbl(1)),j,ichkfg)
      if((ichkfg.ne.0))then
      if((j.eq.2 .and.((chin(istbl(1):ietbl(1)).eq.'or') .or.
     &   (chin(istbl(1):ietbl(1)).eq.'or'))))then
      else
      backspace (ifti)
      goto 900
      endif
      endif
      inost = 1
400   continue
      if((inonw.eq.0.and.ioptid.eq.1))then
      j = ietbl(inost)-istbl(inost)+1
      call chkint(chin(istbl(inost):ietbl(inost)),j,ichkfg)
      if((ichkfg.ne.0))goto 990
      read(chin(istbl(inost):ietbl(inost)),*) iznid
      inost = inost + 1
      endif
      do i=inost,ino
        j = ietbl(i)-istbl(i)+1
        call chkint(chin(istbl(i):ietbl(i)),j,ichkfg)
        if((ichkfg.eq.0))then
          inonw = inonw + 1
          if(inonw.ge.MAX_IZN) then
            write(*,*) 'Dimension over of izndt=',MAX_IZN
            stop
          endif
          read(chin(istbl(i):ietbl(i)),*) izndt(inonw)
          iznor(inonw+1) = '  '
        elseif(j.eq.2 .and.((chin(istbl(i):ietbl(i)).eq.'OR') .or.
     &       (chin(istbl(i):ietbl(i)).eq.'or'))) then
          inonw = inonw + 1
          if((inonw.eq.1))goto 990
          if((iznor(inonw).eq.'OR'.or.iznor(inonw).eq.'or'))goto 990
          iznor(inonw) = chin(istbl(i):ietbl(i))
          inonw = inonw - 1
        else
          goto 990
        endif
      end do
      goto 300
900   continue
      iprm = inonw
      return
990   continue
      write(ifto,'(a,a)') ' zone data error : ',chkey
      write(ifto,'(a)') chin
      stop
      end
!--------------------last line of subroutine freezn.f------------------
                                                                        
!-------------------------------splitc.f--------------------------------
! Version: 051219-1435
! Reference: JNC TN1410 2002-201
!-----------------------------------------------------------------------
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|12

! ----------------------------------------------------------------------
! Required (geometry) subroutine for use with the EGS5 Code System
! ----------------------------------------------------------------------
! This is a subroutine splitc. 
! ----------------------------------------------------------------------
      subroutine splitc(chin,ich,ichs,iche,ino,istbl,ietbl)
      implicit none
      character chin*(*)
      integer i,ich,ichs,iche,ino
      integer istbl(1),ietbl(1)
      integer ichss,ichee,is,ie
      do i=ichs,iche
        if (chin(i:i).lt.' ') then
          chin(i:i)=' '
        end if
      end do
      ichss = ichs
      if((ichss.eq.0))then
        ichss = 1
      endif
      ichee = iche
      if((ichee.eq.0))then
        ichee = ich
      endif
      ino = 0
      is = 0
      ie = 0
      do i=ichss,ichee
        if((is.eq.0.and.chin(i:i).ne.' '))then
          is = i
          ie = i
        elseif(chin(i:i).ne.' ') then
          ie = i
        elseif(is.ne.0) then
          ino = ino + 1
          istbl(ino) = is
          ietbl(ino) = ie
          is = 0
          ie = 0
        endif
        if((i.eq.ichee.and.is.ne.0))then
         ino = ino + 1
         istbl(ino) = is
         ietbl(ino) = ie
         is = 0
         ie = 0
        endif
      end do
      return
      end
!--------------------last line of subroutine splitc.f------------------
                                                                        
!-------------------------------chkint.f--------------------------------
! Version: 051219-1435
! Reference: JNC TN1410 2002-201
!-----------------------------------------------------------------------
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|12

! ----------------------------------------------------------------------
! Required (geometry) subroutine for use with the EGS5 Code System
! ----------------------------------------------------------------------
! This is a subroutine chkint. 
! ----------------------------------------------------------------------
      subroutine chkint(chin,ich,ichkfg)
      implicit none
      character chin*(*)
      integer ich,ichkfg
      integer i
      ichkfg = 0
      do i=1,ich
        if((i.eq.1.and.(chin(i:i).eq.'+'.or.chin(i:i).eq.'-')))then
        elseif(chin(i:i).ge.'0'.and.chin(i:i).le.'9') then
        else
          ichkfg = 1
        endif
      end do
      return
      end
!--------------------last line of subroutine chkint.f------------------
                                                                        
!-------------------------------chkflt.f--------------------------------
! Version: 051219-1435
! Reference: JNC TN1410 2002-201
!-----------------------------------------------------------------------
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|12

! ----------------------------------------------------------------------
! Required (geometry) subroutine for use with the EGS5 Code System
! ----------------------------------------------------------------------
! This is a subroutine chkflt. 
! ----------------------------------------------------------------------
      subroutine chkflt(chin,ich,ichkfg)
      implicit none
      character chin*(*)
      integer ich,ichkfg
      integer i,ie,idot
      ichkfg = 0
      idot = 0
      ie = 0
      do i=1,ich
        if((i.eq.1.and.(chin(i:i).eq.'+'.or.chin(i:i).eq.'-')))then
        elseif(ie.eq.0.and.(chin(i:i).eq.'E'.or.chin(i:i).eq.'e')) then
          ie = 1
        elseif(ie.eq.0.and.(chin(i:i).eq.'D'.or.chin(i:i).eq.'d')) then
          ie = 1
        elseif(ie.eq.1.and.(chin(i:i).eq.'+'.or.chin(i:i).eq.'-')) then
          ie =2
        elseif(idot.eq.0.and.chin(i:i).eq.'.') then
          idot = 1
        elseif(chin(i:i).ge.'0'.and.chin(i:i).le.'9') then
          if((ie.eq.1))ie = 2
        else
         ichkfg = 1
        endif
      end do
      return
      end
!--------------------last line of subroutine chkflt.f------------------
